
{***********************************************************
*** Unit realizzata da Sammarco Francesco
*** per inserire delle combobox/picklist
*** all'interno della DBGrid. Sembra non funzionare con
*** tutti i tipi di DataSet, nel caso qualcuno riesca a
*** migliorare questa unit mi invii il codice migliorato
*** al seguente indirizzo: francesco.sammarco@gmail.com
***********************************************************}
unit Unit_CampoComboDBGrid;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, controls, db, Grids, DbGrids, dbctrls, dialogs;

type
    TReverseIndex = object
      index_in: integer;
      index_out: integer;
    end;

type
    TParametriAddComboBox = object
           NomeNuovoCampo: string;
           MyDataSet: TDataSet;
           CampoDataSet: string;
           DataSetList: TDataSet;
           ChiaveLista: string;
           CampoLista: string
    end;

type TArrayReverseIndex = array of TReverseIndex;
type TStringArray = array of string;
type TArrayTParametriAddComboBox = array of TParametriAddComboBox;

function AddDBComboBoxToGrid(NomeNuovoCampo: string;MyDataSet: TDataSet; CampoDataSet: string ;DataSetList: TDataSet; ChiaveLista: string; CampoLista: string): boolean;
function AddDBComboBoxToGridNew(campi: TArrayTParametriAddComboBox): boolean;
function GetIndexOfColumnFromTitleOLD(aGrid: TDBGrid; aTitle: string): integer;
function GetIndexOfColumnFromTitle(MyDataSet: TDataSet; aTitle: string): integer;
function GetIndexOfColumnsFromTitle(MyDataSet: TDataSet; aTitle1: string; aTitle2: string; var indici: TReverseIndex): boolean;
procedure ExchangeColumns(MyDataSet: TDataSet; indici: TArrayReverseIndex; GestisciChiusuraDataSetAutomaticamente: boolean = true);
procedure ExchangeColumnsOLD(aGrid: TDBGrid; index1, index2: integer);
procedure SetSelectEditor(Sender: TObject; Column: TColumn; var Editor: TWinControl;CampoChiaveDataSet: string; MyDBLookupComboBox: TDBLookupComboBox; Filtro: string = '');
function SetupDBLookupCombo(CampoChiaveDataSet: string; aGrid: TDBGrid; Const aColumn:TColumn; MyDBLookupComboBox: TDBLookupComboBox; Filtro: string = ''):TDBLookupComboBox;
procedure MyDBLookupComboBoxKeyPress(Sender: TObject; var Key: char; aGrid: TDBGrid);

const
  ControlChars  :set of Char = [#0..#30];

implementation

function AddDBComboBoxToGrid(NomeNuovoCampo: string;MyDataSet: TDataSet; CampoDataSet: string ;DataSetList: TDataSet; ChiaveLista: string; CampoLista: string): boolean;
var
  i: integer;
  ret: boolean;
  Field:TField;
begin
       ret:=false;
       try
          try
             MyDataSet.FieldDefs.Update;
             MyDataSet.Close;
             for i:=0 to MyDataSet.FieldDefs.Count-1 do
                 if MyDataSet.FindField(MyDataSet.FieldDefs[i].Name) = nil then
                    Field:=MyDataSet.FieldDefs[i].CreateField(MyDataSet);

             if MyDataSet.FindField(NomeNuovoCampo)<>nil then
                Exit;

             Field:=TStringField.Create(MyDataSet);
             with Field do
             begin
               FieldName:=NomeNuovoCampo;
               Dataset:=MyDataSet;
               FieldKind := fkLookup; //QUI DICO CHE E' UNA COMBOBOX
               LookupDataSet:=DataSetList; //QUI ASSEGNO IL DATASET DA CUI EREDITARE I DATI DA FAR VEDERE NELLA COMBOBOX
               LookupCache:=FALSE;
               LookupKeyFields:=ChiaveLista;//'CHIAVE'; //CHIAVE CHE VERRA' INSERITA NEL CAMPO Temf.KeyFields
               LookupResultField:=CampoLista;//'NOME'; //VALORE CHE VEDI NELLA COMBOBOX DA SELEZIONE
               ReadOnly:=FALSE; //SOLA LETTURA
               ProviderFlags:=[pfInUpdate, pfInWhere];
               Required:=FALSE;
               KeyFields:=CampoDataSet;//'CHIAVEPV';
               //SetFieldType(TFieldType.ftString);
               //Size:=100;
             end;
             MyDataSet.Open;
             ret:=TRUE;
          finally
         end;
       except
             on E: Exception do
             begin

             end;
       end;
       result:=ret;
end;


function AddDBComboBoxToGridNew(campi: TArrayTParametriAddComboBox): boolean;
var
  i, j: integer;
  ret: boolean;
  Field:TField;
begin
  ret:=false;
  try
     try

        for j:=0 to Length(campi)-1 do
        begin


             with campi[j] do
             begin

                  if j=0 then
                  begin
                      MyDataSet.FieldDefs.Update;
                      MyDataSet.Close;
                  end;

                  for i:=0 to MyDataSet.FieldDefs.Count-1 do
                      if MyDataSet.FindField(MyDataSet.FieldDefs[i].Name) = nil then
                         Field:=MyDataSet.FieldDefs[i].CreateField(MyDataSet);


                  if MyDataSet.FindField(NomeNuovoCampo)<>nil then
                  begin

                  end else begin
                       Field:=TStringField.Create(MyDataSet);
                       with Field do
                       begin
                         FieldName:=NomeNuovoCampo;
                         Dataset:=MyDataSet;
                         FieldKind := fkLookup; //QUI DICO CHE E' UNA COMBOBOX
                         LookupDataSet:=DataSetList; //QUI ASSEGNO IL DATASET DA CUI EREDITARE I DATI DA FAR VEDERE NELLA COMBOBOX
                         LookupCache:=FALSE;
                         LookupKeyFields:=ChiaveLista;//'CHIAVE'; //CHIAVE CHE VERRA' INSERITA NEL CAMPO Temf.KeyFields
                         LookupResultField:=CampoLista;//'NOME'; //VALORE CHE VEDI NELLA COMBOBOX DA SELEZIONE
                         ReadOnly:=FALSE; //SOLA LETTURA
                         ProviderFlags:=[pfInUpdate, pfInWhere];
                         Required:=FALSE;
                         KeyFields:=CampoDataSet;//'CHIAVEPV';
                         Size:=500;
                       end;
                  end;

                  if j=Length(campi)-1 then
                     MyDataSet.Open;

             end;





        end;



        ret:=TRUE;
     finally
    end;
  except
        on E: Exception do
        begin

        end;
  end;
  result:=ret;
end;

function GetIndexOfColumnFromTitleOLD(aGrid: TDBGrid; aTitle: string): integer;
var
   gcols: TGridColumns;
   ret, i: integer;
   nomeColonna: string;
begin
       ret:=-1;

       i:=0;
       while ((i < aGrid.Columns.Count)and(ret=-1)) do
       begin
            nomeColonna:=aGrid.Columns[i].FieldName;
            if UpperCase(nomeColonna)=UpperCase(aTitle) then
            begin
                 ret:=i;
            end;
            Inc(i);
       end;
       result:=ret;
end;

function GetIndexOfColumnFromTitle(MyDataSet: TDataSet; aTitle: string
  ): integer;
var
   ret, i: integer;
   nomeColonna: string;
begin
     ret:=-1;
     i:=0;
     while((i<MyDataSet.FieldCount)and(ret=-1))do
     begin
          nomeColonna:=MyDataSet.Fields[i].FieldName;
          if UpperCase(nomeColonna)=UpperCase(aTitle) then
          begin
               ret:=i;
          end else begin
               Inc(i);
          end;
     end;
     result:=ret;
end;

function GetIndexOfColumnsFromTitle(MyDataSet: TDataSet; aTitle1: string;
  aTitle2: string; var indici: TReverseIndex): boolean;
var
   ret: boolean;
   i: integer;
   nomeColonna: string;
begin
     ret:=false;
     indici.index_in:=-1;
     indici.index_out:=-1;
     i:=0;
     while((i<MyDataSet.FieldCount)and(ret=false))do
     begin
          nomeColonna:=MyDataSet.Fields[i].FieldName;
          if UpperCase(nomeColonna)=UpperCase(aTitle1) then
          begin
               indici.index_in:=i;
          end else begin
               if UpperCase(nomeColonna)=UpperCase(aTitle2) then
               begin
                    indici.index_out:=i;
               end;
          end;
          if ((indici.index_in<>-1)and(indici.index_out<>-1)) then
             ret:=true
          else
              Inc(i);
     end;
     result:=ret;
end;

procedure ExchangeColumns(MyDataSet: TDataSet; indici: TArrayReverseIndex;
  GestisciChiusuraDataSetAutomaticamente: boolean);
var
   appoggio, i: integer;
begin
     if GestisciChiusuraDataSetAutomaticamente then
        MyDataSet.Close;
     for i:=0 to Length(indici)-1 do
     begin
          if indici[i].index_in<indici[i].index_out then
          begin
               MyDataSet.Fields[indici[i].index_out].index:=indici[i].index_in;
               MyDataSet.Fields[indici[i].index_in+1].index:=indici[i].index_out;
          end;
     end;
     if GestisciChiusuraDataSetAutomaticamente then
        MyDataSet.Open;
end;
(*           *)
//Vecchia versione che si appoggiava sulla griglia, quella nuova si appoggia sul dataset
procedure ExchangeColumnsOLD(aGrid: TDBGrid; index1, index2: integer);
var
  gcols: TGridColumns;
begin
  gcols:=aGrid.Columns;
  if not (gcols.HasIndex(index1) and gcols.HasIndex(index2))
    then Exit;
  gcols.BeginUpdate;
  gcols.Items[index2].Index:=index1;
  gcols.Items[Index1+1].Index:=index2;
  gcols.EndUpdate;
end;

procedure SetSelectEditor(Sender: TObject; Column: TColumn;
  var Editor: TWinControl; CampoChiaveDataSet: string;
  MyDBLookupComboBox: TDBLookupComboBox; Filtro: string);
var
  vEdt : TWinControl;
  vRect : TRect;
begin
  if Editor = nil then Exit;
  vEdt := SetupDbLookupCombo(CampoChiaveDataSet, TDBGrid(Sender),Column, MyDBLookupComboBox, Filtro);
  if Assigned(vEdt) then begin
    vRect := TDBGrid(Sender).SelectedFieldRect;
    vEdt.SetBounds(vRect.Left,vRect.Top,(vRect.Right-vRect.Left),(vRect.Bottom-vRect.Top));
    Editor := vEdt;
  end;
end;

function SetupDBLookupCombo(CampoChiaveDataSet: string; aGrid: TDBGrid;
  const aColumn: TColumn; MyDBLookupComboBox: TDBLookupComboBox; Filtro: string
  ): TDBLookupComboBox;
var
   LookupResultField: string;
   LookupKeyFields: string;
   app_datasource: TDataSource;
begin
  Result := Nil;
  if aColumn.Field.FieldKind = fkLookup then begin

      LookupResultField := aColumn.Field.LookupResultField;
      LookupKeyFields   := aColumn.Field.LookupKeyFields;

      app_datasource:=TDataSource.Create(nil);
      app_datasource.DataSet := aColumn.Field.LookupDataSet;

      Result := MyDBLookupComboBox;
      Result.AutoComplete := True;
      Result.AutoDropDown := True;
      Result.DataSource   := aGrid.DataSource;
      Result.DataField    := CampoChiaveDataSet;
      Result.ListSource   := app_datasource;
      Result.ListField    := LookupResultField;
      Result.KeyField     := LookupKeyFields;
      Result.Visible      := False;

      Result.ListSource.DataSet.Filtered:=false;
      if Trim(Filtro)<>'' then
      begin
           Result.ListSource.DataSet.Filter:=Filtro;
           Result.ListSource.DataSet.Filtered:=true;
      end;

      app_datasource.Free();

  end;
end;

procedure MyDBLookupComboBoxKeyPress(Sender: TObject; var Key: char;
  aGrid: TDBGrid);
var
  vKey : Char;
begin
  vKey := Key;
  aGrid.EditorKeyPress(Sender, Key);
  //if (Key = #0) and (not (Key in ControlChars)) then
  Key := vKey;
end;


end.

